#
#  proxio.py
#
#  Author  : Ahmed Obied (ahmed.obied@gmail.com)
#  Date    : 01/2008
#  Version : 0.1
#
#  Proxio is a script for checking the connectivity of proxies. 
#

import sys
import socket
import string

TIME_OUT = 5

def error(func):
    type = sys.exc_info()[1]
    sys.stderr.write("[*] ERROR: (%s) %s\n" % (func, type))
    sys.exit(1)
                
def get_list(file_name):
    p_list = []
    try:
        fd = open(file_name,"r")
        lines = fd.readlines()
        for line in lines:
            entry = string.split(line,":")
            if len(entry) == 2:
                ip, port = entry[0], entry[1]
                tup = (ip, string.atoi(port))
                p_list.append(tup)
    except:
        error("get_list")
    return p_list

if __name__ == "__main__":
    argc = len(sys.argv)
    if argc != 2:
        sys.stdout.write("Usage: %s [input list]\n" % sys.argv[0])
        sys.exit(1)
    sys.stdout.write("[***] proxio [***]\n\n")
    p_list = get_list(sys.argv[1])
    for i in p_list:
        ip, port = i
        sock = socket.socket(socket.AF_INET,socket.SOCK_STREAM,socket.IPPROTO_TCP)
        try:
            sock.settimeout(TIME_OUT)
            sock.connect(i)   
            sys.stdout.write("[-] %s:%d (up)\n" % (ip,port))
        except:
            sys.stdout.write("[-] %s:%d (down)\n" % (ip,port))
        sock.close()
    sys.stdout.write("\n[***] Done [***]\n")
